﻿@model Work
@{
    bool IsPresent = Convert.ToBoolean(Model?.IsPresent);
}
<div class="modal-dialog modal-dialog-scrollable" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">@(Model?.Id>0?"Edit" :"Add") Work</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <form id="workFrm" action="adviser/profile/SaveWork" class="form fv-plugins-bootstrap fv-plugins-framework" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormCompleteWork">
            <div class="modal-body scrollable-modal-body">
                <span id="msg"></span>
                <input asp-for="Guid" />
                <div class="form-group">
                    <label asp-for="Company"></label>
                    <input asp-for="Company" class="form-control form-control-lg capitalize">
                    <span asp-validation-for="Company" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Position"></label>
                    <input asp-for="Position" class="form-control form-control-lg capitalize" >
                    <span asp-validation-for="Position" class="text-danger"></span>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label asp-for="State"></label>
                            <select asp-for="State" class="form-control form-control-lg" data-live-search="true" data-live-search-style="startsWith"></select>
                            <span asp-validation-for="State" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label asp-for="City"></label>
                            <div class="typeahead">
                                <input asp-for="City" class="form-control form-control-lg"/>
                            </div>
                            <span asp-validation-for="City" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    <div class="col-1 mt-2">
                        <span class="switch switch-icon switch-sm switch-custom">
                            <label>
                                <input type="checkbox" asp-for="IsPresent">
                                <span></span>
                            </label>
                        </span>
                    </div>
                    <label class="switch-label col-form-label ml-7" asp-for="IsPresent">
                        Is this your current company?
                    </label>
                </div>
                <div class="row">
                    <div class="col-md-9">
                        <div class="form-group mb-0" id="FromTo">
                            <label>
                                Duration (From Year & To Year)
                            </label>
                            <div class="input-group">
                                <input asp-for="FromYear" class="form-control form-control-lg yearmask">
                                <div class="input-group-append input-group-prepend">
                                    <span class="input-group-text bg-primary-o-40 border border-primary">
                                        To
                                    </span>
                                </div>
                                <input class="form-control form-control-lg @(IsPresent?"" :"d-none")" disabled value="Present" id="PresentText" />
                                <input asp-for="ToYear" class="form-control form-control-lg yearmask @(!IsPresent?"" :"d-none")" disabled="@(!string.IsNullOrEmpty(Model?.ToYear) ? null:"disabled")" />
                            </div>
                            <span asp-validation-for="FromYear" class="text-danger" id="fromYear-Msg"></span>
                            <span asp-validation-for="ToYear" class="text-danger" id="toYear-Msg"></span>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button class="btn btn-primary font-weight-bold px-6 py-2" id="btn_submit_adviser">
                    <i class="la la-save"></i>Save
                </button>
            </div>
        </form>
    </div>
</div>
<style>
    .typeahead .tt-menu {
        min-width: 200px;
    }
</style>
<script src="~/lib/lodash.min.js"></script>
<script src="~/JSON/usa-state-city.js"></script>
<script>
    var bindCityFromState = function () {
        var state = $("#State").val();
        var cities = _.sortBy(countries_states[state]);
        $("#City").typeahead("destroy");
        $('#City').typeahead({
            highlight: true,
            minLength: 0
        }, {
                name: 'cities',
                source: substringMatcher(cities)
        });
    }
    var html = "";
    var countries = _.sortBy(countries_states);
    $.each(countries_states, function (key) {
        html += `<option>${key}</option>`
    });
    $("#State").html(html);
    setTimeout(function () {
        $('#State').selectpicker('render');
        $("#State").val('@Model?.State');
        $("#State").selectpicker("refresh");
        bindCityFromState();
    }, 0);
    $("#State").change(function (e) {
        $("#City").val("");
        $("#City").attr("placeholder", `City of ${e.target.value}`);
        bindCityFromState();
    });
    $("#IsPresent").change(function (e) {
        var selection = $(this).is(":checked");
        if (selection) {
            $("#PresentText").removeClass("d-none");
            $("#ToYear").addClass("d-none");
            $("#ToYear").val("");
        }
        else {
            $("#PresentText").addClass("d-none");
            $("#ToYear").removeClass("d-none");
            var startDate = $("#FromYear").val();
            var validStartDate = !startDate.includes("m") && !startDate.includes("y") && startDate != "";
            if (validStartDate)
                $("#ToYear").prop("disabled", false);
        }
    });
    $('#FromYear').datepicker({
        format: "mm/yyyy",
        autoclose: true,
        minViewMode: "months",
        endDate: new Date()
    });
    $('#ToYear').datepicker({
        format: "mm/yyyy",
        autoclose: true,
        minViewMode: "months",
        startDate:'@Model?.FromYear'
    });
    $('#FromYear').on('changeDate input', function (selected) {
        startDate = $("#FromYear").val();
        $('#ToYear').datepicker('setStartDate', startDate);
        $('#ToYear').prop("disabled", true);
        var fromDate = $("#FromYear").val();
        var spfromDate = fromDate.split("/");
        var d2 = new Date(`${spfromDate[1]}-${spfromDate[0]}`);
        var today = new Date();
        var validStartDate = !startDate.includes("m") && !startDate.includes("y") && startDate != "" && d2 < today ;
        if (validStartDate) {
            $('#ToYear').prop("disabled", false);
            $("#toYear-Msg").removeClass("d-none");
        }
        else {
            if (d2 > today) {
                $("#workFrm").resetValidation();
                $("#fromYear-Msg").addClass("field-validation-error");
                $("#fromYear-Msg").html('From Year must be less than today');
            }
            else {
                $("#ToYear").val("");
                $("#toYear-Msg").addClass("d-none");
                $("#ToYear").removeClass("input-validation-error");
                $("form").valid();
            }
        }
    });
    $('#ToYear').on('changeDate input', function (selected) {
        var fromDate = $("#FromYear").val();
        var toDate = $("#ToYear").val();
        if (!toDate.includes("m") && !toDate.includes("y")) {
            var spfromDate = fromDate.split("/");
            var sptoDate = toDate.split("/");
            var d1 = new Date(`${spfromDate[1]}-${spfromDate[0]}`);
            var d2 = new Date(`${sptoDate[1]}-${sptoDate[0]}`);
            if (d1 > d2) {
                $("#workFrm").resetValidation();
                $("#toYear-Msg").addClass("field-validation-error");
                $("#toYear-Msg").html('To Year must be greater than From Year');
            }
        }
    });
    var onFormCompleteWork = function (response) {
        var id = $(this).find(":submit").attr('id');
        id = id == undefined ? $(frm).find(":submit").attr('id') : id;
        var btn = KTUtil.getById(id);
        var frm_id = $(this).attr('id');
        frm_id = frm_id == undefined ? $(frm).attr('id') : frm_id;
        var responseObj = JSON.parse(response.responseText);
        var workinfo = responseObj.data.workInfo;
        if (responseObj) {
            if (responseObj.success) {
                var modalId = $('.modal:visible').attr("id");
                $(`#${modalId}`).modal('hide');
                var div = $(`#workinfo-${workinfo.guid}`)
                if (div.length > 0)
                    $(`#workinfo-${workinfo.guid}`).html($("#work-template").tmpl(responseObj.data));
                else {
                    responseObj.data.action = "add";
                    $("#work-main-div").append($("#work-template").tmpl(responseObj.data));
                }
                toastr.clear();
                toastr.options = toastrOptions;
                toastr.success(responseObj.message);
            }
            else
                _showFormMessage(`${frm_id}`, "danger", responseObj.message, "fas fa-exclamation-triangle");
        }
        else
            _showFormMessage(`${frm_id}`, "danger", "Error Occur", "fas fa-exclamation-triangle")
        KTUtil.btnRelease(btn);
    };
</script>
<script id="work-template" type="text/html">
    {{if action=="add"}}
    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 work-info-div d-flex" id="workinfo-${workInfo.guid}">
        {{/if}}
        <div class="card card-custom gutter-b shadow-none work-card bg-gray-100 w-100" style="border:1px solid #0e70b5">
            <div class="card-header work-header" style="background:#0e70b5">
                <div class="card-title m-0 w-75">
                    <h3 class="card-label font-size-h4">
                        <span class="font-weight-bold font-size-h4 text-white">${workInfo.company}</span>
                    </h3>
                </div>
                <div class="card-toolbar m-0">
                    <div class="example-tools">
                        <button class="btn btn-icon btn-sm btn-work-edit" data-guid="${workInfo.guid}">
                            <i class="fas fa-pencil-alt text-white" data-toggle="tooltip" data-original-title="Edit"></i>
                        </button>
                        <button class="btn btn-icon btn-sm btn-work-delete" data-guid="${workInfo.guid}">
                            <i class="far fa-trash-alt text-white" data-toggle="tooltip" data-original-title="Delete"></i>
                        </button>
                    </div>
                </div>
            </div>
            <div class="card-body">
                <div class="font-size-h6">
                    <div class="d-flex align-items-start">
                        <span class="col-md-4 text-dark font-weight-bold p-0">Position:</span>
                        <span class="col-md-8 p-0">${workInfo.position}</span>
                    </div>
                    <div class="d-flex align-items-start">
                        <span class="col-md-4 text-dark font-weight-bold p-0">State:</span>
                        <span class="col-md-8 p-0">${workInfo.state}</span>
                    </div>
                    <div class="d-flex align-items-start">
                        <span class="col-md-4 text-dark font-weight-bold p-0">City:</span>
                        <span class="col-md-8 p-0">${workInfo.city}</span>
                    </div>
                    <div class="d-flex align-items-start">
                        <span class="col-md-4 text-dark font-weight-bold p-0">Duration:</span>
                        <span class="col-md-8 p-0">${workInfo.fromYearString} - ${workInfo.toYearString}</span>
                    </div>
                </div>
            </div>
        </div>
        {{if action=="add"}}
    </div>
    {{/if}}
</script>